A=[1.1 1;0 0.8];
B=[0;1];
C=[1 0];
D=0;

K=-place(A,B,[.8+.2*j .8-.2*j])
F=inv(C*inv(eye(2)-A-B*K)*B+D)

% Calcola la funzione di trasferimento ad anello chiuso da r a y
%syms z
%G=C*inv(z*eye(2)-(A+B*K))*B*F

x0=[0;0];
r=1;

XX=x0;
RR=[];
UU=[];
YY=[];
TT=[];

x=x0;

T=40;
for k=1:T,
   u=K*x+F*r;
   y=C*x;
   x=A*x+B*u;
   
   UU=[UU,u];
   YY=[YY,y];
   
   TT=[TT,k-1];
   RR=[RR,r];
   if k<T,
      XX=[XX,x];
   end
end


figure(1)
h=plot(TT,YY,TT,RR);
set(h,'linewidth',1.5);
grid

XX=x0;
RR=[];
UU=[];
YY=[];
TT=[];
x=x0;
d=.01;


T=40;
for k=1:T,
   u=K*x+F*r+d;
   y=C*x;
   x=A*x+B*u;
   
   UU=[UU,u];
   YY=[YY,y];
   
   TT=[TT,k-1];
   RR=[RR,r];
   if k<T,
      XX=[XX,x];
   end
end


figure(2)
h=plot(TT,YY,TT,RR);
set(h,'linewidth',1.5);
grid


K=-place([A zeros(2,1);C 1],[B;0],[.8+.2*j .8-.2*j .3]);
H=K(3);
K=K(1:2);

XX=x0;
QQ=[];
UU=[];
YY=[];
TT=[];
x=x0;
d=1;
q=0;

T=40;
for k=1:T,
   y=C*x;
   u=K*x+H*q+d;
   x=A*x+B*u;
   q=q+y;
   
   UU=[UU,u];
   YY=[YY,y];
   
   TT=[TT,k-1];
   QQ=[QQ,q];
   if k<T,
      XX=[XX,x];
   end
end


figure(3)
h=plot(TT,YY);
set(h,'linewidth',1.5);
grid


XX=x0;
QQ=[];
RR=[];
UU=[];
YY=[];
TT=[];
x=x0;
d=1;
q=0;
r=1;

T=40;
for k=1:T,
   y=C*x;
   u=K*x+H*q+d;
   x=A*x+B*u;
   q=q+y-r;
   
   UU=[UU,u];
   YY=[YY,y];
   
   TT=[TT,k-1];
   QQ=[QQ,q];
   RR=[RR,r];
   if k<T,
      XX=[XX,x];
   end
end


figure(4)
h=plot(TT,YY,TT,RR);
set(h,'linewidth',1.5);
grid


Qy=1;
QI=1;
R=10;

K=-dlqr([A zeros(2,1);C 1],[B;0],[C'*Qy*C,zeros(2,1);zeros(1,2),QI],R);
H=K(3);
K=K(1:2);



XX=x0;
QQ=[];
RR=[];
UU=[];
YY=[];
TT=[];
x=x0;
q=0;
r=1;
d=0;

T=40;
for k=1:T,
   y=C*x;
   u=K*x+H*q+d;
   x=A*x+B*u;
   q=q+y-r;
   
   UU=[UU,u];
   YY=[YY,y];
   
   TT=[TT,k-1];
   QQ=[QQ,q];
   RR=[RR,r];
   if k<T,
      XX=[XX,x];
   end
end


figure(5)
subplot(121)
h=plot(TT,YY,TT,RR);
set(h,'linewidth',1.5);
grid
subplot(122)
h=plot(TT,UU);
set(h,'linewidth',1.5);
grid